/*************************************************************************
* File 		: include/linux/ktau/ktau_inst.h
* Version	: $Id: ktau_inst.h,v 1.1 2005/06/29 16:01:19 suravee Exp $
*************************************************************************/

#ifndef _KTAU_INST_H_
#define _KTAU_INST_H_

/*
 * KTAU EVENT MAPPING
 */
#define	KTAU_EVENT_SCHED		300
#define	KTAU_EVENT_SOFTIRQ		301
#define	KTAU_EVENT_TASKLET		302
#define	KTAU_EVENT_HI_TASKLET		303
#define	KTAU_EVENT_WORKQUEUE		304
#define	KTAU_EVENT_TIMER_SOFTIRQ	305
#define	KTAU_EVENT_TCP_SLOWPATH		306

#define KTAU_EXCEPTION_BASE		500

#define GET_KTAU_INDEX()         static unsigned int ktau_index;\
				 if(!ktau_index) ktau_index = get_ktau_index() 

/*
 * Return the global function index for hash table
 */
extern unsigned int get_ktau_index(void);

/* 
 * This will be used for timer type profiling.
 */
#define ktau_start_timer(x)	ktau_start_prof(ktau_index,(unsigned int)x)
#define ktau_stop_timer(x)	ktau_stop_prof(ktau_index,(unsigned int)x)

extern void ktau_start_prof(unsigned int index, unsigned int addr);
extern void ktau_stop_prof(unsigned int index, unsigned int addr);

/* 
 * This will be used for event type profiling
 */
extern void ktau_event_prof(unsigned int index, unsigned int addr);

#endif /*_KTAU_INST_H_ */
